#!/usr/bin/env python

import gtk
import nautilus
import commands
import re
import os
import urllib

FORMATS = ["application/x-iso", "application/x-cd-image"]


def alert(message):
    """A function to debug"""
    dialog = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_CLOSE, message)
    dialog.run()
    dialog.destroy()



class MountImageExtension(nautilus.MenuProvider):
    def __init__(self):
        self.file_names = []


    def menu_activate_cb_m(self, menu, path):
        """Called when the user selects the Mount menu."""

        name = os.path.basename(path)

        os.system("gksudo -k 'mkdir /media/" + name + "'")
        os.system("gksudo -k 'mount -o loop -t iso9660 " + path + " /media/" + name + "'")


    def menu_activate_cb_u(self, menu, path):
        """Called when the user selects the Unmount menu."""

        name = os.path.basename(path)

        os.system("gksudo -k 'umount /media/" + name + "'")
        os.system("gksudo -k 'rm -rf /media/" + name + "'")


    def get_file_items(self, window, files):
        """Called when the user selects a file in Nautilus."""

        # This script will only accept one file
        if len(files) > 1:
            return

        f = files[0]
        if f.get_mime_type() in FORMATS:
            path = urllib.unquote(f.get_uri()[7:])
        else:
            return


        # Check whether we have show the mount or the unmount menu
        mount_points = commands.getoutput("mount")

        name = os.path.basename(path)
        present = re.search("/media/" + name, mount_points)

        if present:
            item = nautilus.MenuItem("NautilusPython::mount_image_item",
                                     "Unmount image" ,
                                     "Unmount image",
                                     os.path.expanduser("/usr/lib/nautilus/extensions-1.0/python/nautilus-mount-image.png"))
            item.connect("activate", self.menu_activate_cb_u, path)
        else:
            item = nautilus.MenuItem("NautilusPython::mount_image_item",
                                     "Mount image" ,
                                     "Mount image",
                                     os.path.expanduser("/usr/lib/nautilus/extensions-1.0/python/nautilus-mount-image.png"))
            item.connect("activate", self.menu_activate_cb_m, path)

        return item,




